/*
 * @(#) $Id:  $
 *
 * Copyright 2009/2010 by sIT Solutions,
 * A-1110 Wien, Geiselbergstr.21-25.
 * All rights reserved.
 *
 */
package at.spardat.xma.mdl;

import at.spardat.enterprise.fmt.IFmt;

public interface IFormattable {

    /**
     * Returns a clone of the associated Formatter or null if none is associated.
     *
     * @return the attached formatter
     */
    public IFmt getFmt();

    /**
     * Sets a new Formatter.
     *
     * @param formatter to be set. It must be compatible to the type set in the superclass.
     *         For type T_STRING, any formatter may be set. For the other types, the type of the
     *         formatter must be compatible with the type specified in the superclass. For
     *         instance, if the type is T_BCD, only instances of ABcdFmt are allowed.
     * @exception IllegalArgumentException if the provided formatter is not type compatible
     */
    public void setFmt(IFmt formatter);
    
    /**
     * Returns true if the MANDATORY style has been set at construction time 
     */
    public boolean isMandatory();
    
    /**
     * Sets the mandatory-property.
     * 
     * @param what the new value of the mandatory-value
     */
    public void setMandatory (boolean what);
    
    /**
     * Returns true if the widget contains a valid value.
     */
    public boolean isValid();
    
}
