/*******************************************************************************
 * Copyright (c) 2003, 2007 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/

/*
 * Created on 29.10.2003
 *
 *
 *
 */
package at.spardat.xma.security;

import java.util.EventListener;

/**
 * This class defines the interface which must be implemented by
 * every object which wishes to be informed of changes in the XMAContext.
 *
 * @author s2877
 */
public interface ContextChangeListener extends EventListener {
    /**
     * Called befor the context changes.
     * If any of the listeners calls event.setDoit(false),
     * the context will not be changed.
     * @param event containing the changeType and doit.
     */
    void contextWillChange(VotingEvent event);

    /**
     * Called imediately after the context has changed.
     * Here data related to the old context can be discarded
     * and data related to the new context can be loaded.
     * @param event containing old and new context
     */
    void contextChanged(ContextChangeEvent event);

    /**
     * Called if the context change failed on the server side.
     * The recommended action is to show the exception and close the application.
     * @param event containing old and new context
     * @param exception explaining the failure
     */
    void contextChangeFailed(ContextChangeEvent event,Exception exception);
}
