/*******************************************************************************
 * Copyright (c) 2003, 2007 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 *******************************************************************************/

//@(#) $Id: Serializer.java 2089 2007-11-28 13:56:13Z s3460 $
package at.spardat.xma.serializer;

import at.spardat.xma.util.ByteArray;

/**
 * Used to map a sequence of primitive types to a byte array.
 *
 * @author YSD, 11.02.2005
 */
public interface Serializer extends XmaOutput {

    /**
     * Returns the array of bytes that is the result of the serialization process.
     *
     * @return object of type ByteArray holding the result
     */
    public ByteArray getResult ();

    /**
     * Returns whether this is produced at the server or at the client.
     */
    public boolean isAtServer();

    /**
     * Indicates that the result-ByteArray should include a header.
     * Default is to not include a header. Must be called before
     * any data is serialized in this.
     */
    public void addHeader ();

}
